// src/backend/python_policy_manager.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef PYTHON_POLICY_MANAGER_HH
#define PYTHON_POLICY_MANAGER_HH 1

#include "config.h"

#include <Python.h>

#include "../policy_manager.hh"
#include "python_policy.hh"

namespace sgpem
{
	//class PolicyManager;
	class PythonPolicyManager;
	
	class SG_DLLEXPORT PythonPolicyManager : public PolicyManager
	{
	public:  
					
		Policy&						get_policy();
		void						init();
		PyObject*					get_py_dict();
		
		static PythonPolicyManager&     get_instance();	
		
	private:
		PythonPolicyManager();	       //dummy parameter
		static PythonPolicyManager* 	_instance;
		std::auto_ptr<PythonPolicy>	_python_policy;
	};

}

#endif
