// src/backend/scheduler.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef SCHEDULER_HH
#define SCHEDULER_HH 1
namespace sgpem
{
	class Policy;
}

#include "config.h"

#include <limits>


#include "observed_subject.hh"
#include "history.hh"
#include "schedulable_list.hh"

namespace sgpem
{
	class Scheduler;

	/**	\brief 
	
	*/

	class SG_DLLEXPORT Scheduler
	{
	public:
		enum event
		{
			event_schedulable_arrival,
			event_schedulable_termination,
			event_end_time_slice
		};

		static Scheduler&  			get_instance();
		SchedulableList*			get_ready_queue();
		void 						reset_status();
		void 						step_forward();
		void						set_policy(Policy*);
		Policy* 					get_policy();
				
		
	private:
		Scheduler(int);					//private constructor. The parameter is discarded
		static Scheduler  	_instance;
		SchedulableList		_ready_queue;
		Policy* 			_policy;
	};

}//~ namespace sgpem

#endif //SCHEDULER_HH




