// src/backend/text_simulation.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef TEXT_SIMULATION_HH
#define TEXT_SIMULATION_HH 1

#include "config.h"
#include "gettext.h"

#include "simulation.hh"
#include "io_manager.hh"
#include "templates/smartp.hh"
#include "backend/string_utils.hh"
#include "backend/policy_parameters.hh"


#include <glibmm/thread.h>
#include <glibmm/ustring.h>
#include <utility>


namespace sgpem
{
	class TextSimulation;

  /** 
  
   */	
	class SG_DLLEXPORT TextSimulation : public Simulation, public sigc::trackable
	{
	public:
		~TextSimulation();
		
		static void	parse_command(std::pair< std::pair<TextSimulation*, int>, const Glib::ustring >);
		void	add_io_device(memory::smart_ptr<IOManager>);
		void	update();
		
	private:
		std::vector<memory::smart_ptr<IOManager> > _devices;		
		static void	_io_loop(std::pair<TextSimulation*, int>);
	};
  
}


#endif